package com.sun.java.swing.plaf.motif;

import java.awt.Component;
import javax.swing.UIManager;
import java.awt.Color;
import java.io.Serializable;
import javax.swing.Icon;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.plaf.ComponentUI;
import java.awt.Graphics;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicTreeUI;

public class MotifTreeUI extends BasicTreeUI
{
    static final int HALF_SIZE = 7;
    static final int SIZE = 14;
    
    public MotifTreeUI() {
    }
    
    @Override
    public void installUI(JComponent c) {
        super.installUI(c);
    }
    
    @Override
    protected void paintVerticalLine(Graphics graphics, JComponent component, int n, int n2, int n3) {
        if (this.tree.getComponentOrientation().isLeftToRight()) {
            graphics.fillRect(n, n2, 2, n3 - n2 + 2);
        }
        else {
            graphics.fillRect(n - 1, n2, 2, n3 - n2 + 2);
        }
    }
    
    @Override
    protected void paintHorizontalLine(Graphics graphics, JComponent component, int n, int n2, int n3) {
        graphics.fillRect(n2, n, n3 - n2 + 1, 2);
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new MotifTreeUI();
    }
    
    public TreeCellRenderer createDefaultCellRenderer() {
        return new MotifTreeCellRenderer();
    }
    
    public static class MotifExpandedIcon implements Icon, Serializable
    {
        static Color bg;
        static Color fg;
        static Color highlight;
        static Color shadow;
        
        public MotifExpandedIcon() {
            MotifTreeUI.MotifExpandedIcon.bg = UIManager.getColor("Tree.iconBackground");
            MotifTreeUI.MotifExpandedIcon.fg = UIManager.getColor("Tree.iconForeground");
            MotifTreeUI.MotifExpandedIcon.highlight = UIManager.getColor("Tree.iconHighlight");
            MotifTreeUI.MotifExpandedIcon.shadow = UIManager.getColor("Tree.iconShadow");
        }
        
        public static Icon createExpandedIcon() {
            return new MotifTreeUI.MotifExpandedIcon();
        }
        
        @Override
        public void paintIcon(Component component, Graphics graphics, int n, int n2) {
            graphics.setColor(MotifTreeUI.MotifExpandedIcon.highlight);
            graphics.drawLine(n, n2, n + 14 - 1, n2);
            graphics.drawLine(n, n2 + 1, n, n2 + 14 - 1);
            graphics.setColor(MotifTreeUI.MotifExpandedIcon.shadow);
            graphics.drawLine(n + 14 - 1, n2 + 1, n + 14 - 1, n2 + 14 - 1);
            graphics.drawLine(n + 1, n2 + 14 - 1, n + 14 - 1, n2 + 14 - 1);
            graphics.setColor(MotifTreeUI.MotifExpandedIcon.bg);
            graphics.fillRect(n + 1, n2 + 1, 12, 12);
            graphics.setColor(MotifTreeUI.MotifExpandedIcon.fg);
            graphics.drawLine(n + 3, n2 + 7 - 1, n + 14 - 4, n2 + 7 - 1);
            graphics.drawLine(n + 3, n2 + 7, n + 14 - 4, n2 + 7);
        }
        
        @Override
        public int getIconWidth() {
            return 14;
        }
        
        @Override
        public int getIconHeight() {
            return 14;
        }
    }
    
    public static class MotifCollapsedIcon extends MotifTreeUI.MotifExpandedIcon
    {
        public static Icon createCollapsedIcon() {
            return new MotifTreeUI.MotifCollapsedIcon();
        }
        
        @Override
        public void paintIcon(Component component, Graphics graphics, int n, int n2) {
            super.paintIcon(component, graphics, n, n2);
            graphics.drawLine(n + 7 - 1, n2 + 3, n + 7 - 1, n2 + 10);
            graphics.drawLine(n + 7, n2 + 3, n + 7, n2 + 10);
        }
    }
}
